// Steam Simulator, A.Greensted
// July 2010
// http://www.labbookpages.co.uk

package steamSim;

import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.*;

public class StreamHandler
{
	private static JFileChooser fileChooser;

	static
	{
		fileChooser = new JFileChooser();
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Steam Engine Data File", "sed");
		fileChooser.setFileFilter(filter);
	}

	public static InputStream getOpenStream(JFrame frame)
	{
		int returnVal = fileChooser.showOpenDialog(frame);

		if (returnVal == JFileChooser.APPROVE_OPTION)
		{
			try
			{
				return new FileInputStream(fileChooser.getSelectedFile());
			}
			catch (FileNotFoundException e) {}
		}

		return null;
	}

	public static OutputStream getSaveStream(JFrame frame)
	{
		int returnVal = fileChooser.showSaveDialog(frame);

		if (returnVal == JFileChooser.APPROVE_OPTION)
		{
			try
			{
				return new FileOutputStream(fileChooser.getSelectedFile());
			}
			catch (FileNotFoundException e) {}
		}

		return null;
	}
}
