// Steam Simulator, A.Greensted
// July 2010
// http://www.labbookpages.co.uk

package steamSim;

import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.*;
import javax.jnlp.*;

public class WSStreamHandler
{
	static
	{
		ServiceManager.getServiceNames();
	}

	public static InputStream getOpenStream(JFrame frame)
	{
		try
		{
			FileOpenService fos = (FileOpenService) ServiceManager.lookup("javax.jnlp.FileOpenService"); 

			// Null is return if cancelled by user
			FileContents fileContents = fos.openFileDialog(null, new String[] {"sed"}); 
			if (fileContents == null) return null;

			return fileContents.getInputStream();
		}
		catch (Exception e)
		{
			System.err.println("WSStreamHandler.getOpenStream:");
			System.err.println(e);
		}

		return null;
	}

	public static OutputStream getSaveStream(JFrame frame)
	{
		final PipedInputStream pipedInputStream;
		PipedOutputStream pipedOutputStream = null;

		try
		{
			pipedInputStream = new PipedInputStream();
			pipedOutputStream = new PipedOutputStream(pipedInputStream);
		}
		catch (Exception e)
		{
			System.err.println("WSStreamHandler.getSaveStream:");
			System.err.println(e);
			return null;
		}

		Thread writeThread = new Thread(new Runnable()
		{
			public void run()
			{
				try
				{
					FileSaveService fos = (FileSaveService) ServiceManager.lookup("javax.jnlp.FileSaveService"); 
					FileContents fileContents = fos.saveFileDialog(null, new String[] {"sed"}, pipedInputStream, null); 
				}
				catch (Exception e)
				{
					System.err.println("WSStreamHandler.getSaveStream: writeThread Exception");
				}
			}
		});

		writeThread.start();

		return pipedOutputStream;
	}
}
